#include <iostream>
#include <iomanip>
#include <cmath>
using namespace std;

class int_znach{
	char *name;                       //   
public:
	int_znach() {name= "0";};
	int_znach(char *stroka) {name= stroka;};
	double intr_arr[5][3];           //(  ): ,  ,    ( 1)
	double ints_arr[5][3];           //(  ): ,  ,    ( -)
	void shov();                     // 
};

void int_znach::shov()
{
	cout << "  :  " <<name <<"\n";
	cout <<setw(8) <<"" <<setw(29) <<" . :" <<setw(28) <<". :\n";
	cout <<setw(8) <<"" <<setw(17) <<"" <<setw(14) <<"-" <<setw(17) <<"" <<setw(14) <<"-\n";
	for(int i= 0; i < 5; i++)
	{
		cout <<setprecision(4)<<setw(7) <<intr_arr[i][0]; 
		cout <<setprecision(0) <<setw(14) <<intr_arr[i][1];
		cout <<setprecision(0) <<setw(15) <<ints_arr[i][1];
		cout <<setprecision(6) <<setw(17) <<intr_arr[i][2];
		cout <<setprecision(6) <<setw(15) <<ints_arr[i][2] <<"\n";

//		cout <<ints_arr[j][0];
//		cout <<ints_arr[j][1];
//		cout <<ints_arr[j][2];
	}
	cout <<"\n";

}

//-----------------------------------------------------------------------------------------------------------------------------------------------------------------------
double f1(double x);
double f2(double x);
double f3(double x);
double f4(double x);
double intrect(double (*f)(double), double a, double b, double eps, double &n);     // 
double intsum(double (*f)(double), double a, double b, double eps, double &n);      // - 

//------------------------------------------------------------------------------------- main---------------------------------------------------------------------------------
int main()
{
	setlocale(0, "russian");
	cout.setf(ios::fixed);
	int_znach obiz[4]=                                     //  4  .   .
	{
		int_znach("y= x"), 
		int_znach("y= sin(22*x)"), 
		int_znach("y= x*x*x*x"), 
		int_znach("y= arctg(x)")
	}; 
	double (*pf[4])(double)= {f1, f2, f3, f4};
	double integral, n=10;
	double xn= -1, xk= 3;                                   //,        
	cout << " \n";

	cout <<"\n :\n";
	integral=(xk*xk-xn*xn)/2.0;
	cout <<"y= x - " << integral <<"\n";
	integral=(cos(xn*22.0)-cos(xk*22.0))/22.0;
	cout <<"y= sin(22*x) - " << integral <<"\n";
	integral=(xk*xk*xk*xk*xk-xn*xn*xn*xn*xn)/5.0;
	cout <<"y= x*x*x*x - " << integral <<"\n";
	integral=xk*atan(xk)-xn*atan(xn)-(log(xk*xk+1)-log(xn*xn+1))/2.0;
	cout <<"y= arctg(x) - " << integral <<"\n\n";

	double eps=1;
	for(int j= 0; j < 5; j++)
	{
		for(int i=0; i < 4; i++)
		{
			obiz[i].intr_arr[j][0]= eps;
			integral= intrect(pf[i], xn, xk, eps, n);
			obiz[i].intr_arr[j][2]= integral;
			obiz[i].intr_arr[j][1]= (n/2);
			n= 10;
		}

		for(int i=0; i <= 3; i++)
		{
			obiz[i].ints_arr[j][0]= eps;
			integral= intsum(pf[i], xn, xk, eps, n);
			obiz[i].ints_arr[j][2]= integral;
			obiz[i].ints_arr[j][1]= (n/2);
			n= 10;
		}
		eps/= 10;
	}


	for(int i=0; i < 4; i++)
	{
		obiz[i].shov();
	}
	system("PAUSE");
	return 0;
}

//-------------------------------------------------------------------------------------------------------------------------------------------------------------------------
double intrect(double (*f)(double), double a, double b, double eps, double &n)                // 
{
	double dx, sc, sn, x;
	sn= 0;
	do{
		sc= sn;
		dx= (b-a)/n;
		x= a;
		sn= f(x)*dx;
		for(int i= 0; i < n; i++)
		{
			x+= dx;
			sn+= f(x)*dx;
		}	
		n*= 2;
//		n+= ceil(n/10);
	}while(abs(sn-sc) > eps);
	return sn;
}

double intsum(double (*f)(double), double a, double b, double eps, double &n)                 // - 
{
	double x, dx, s1, s2, y1, y2;
	do{	
		dx= (b-a)/n;
		s1= s2=0;
		x= a;
		for(int i= 0; i < n; x+= dx, i++)
		{
			y1 = f(x);			     //      
			y2 = f(x + dx);  		 //     
			if(y1 <= y2 )               	 //  
			{
				s1 += y1 * dx;                  //  
				s2 += y2 * dx;                 //   
			}
			else                              //  
			{  
				s2 += y1 * dx;         //   
				s1 += y2 * dx;         //   
			}	
		}
		n*= 2;
//		n+= ceil(n/10);
	}while((s2-s1) >= eps);
	return s1;
}

double f1(double x) {return x;}
double f2(double x) {return sin( 22 * x );}
double f3(double x) {return x*x*x*x;}
double f4(double x) {return atan(x);}